CfnTopic L1 construct
The AWS::SNS::Topic resource creates a topic to which notifications can be published.
One account can create a maximum of 100,000 standard topics and 1,000 FIFO topics. For more information, see Amazon endpoints and quotas in the AWS General Reference .
Example
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import { aws_sns as sns } from 'aws-cdk-lib';
declare const archivePolicy: any;
declare const dataProtectionPolicy: any;
const cfnTopic = new sns.CfnTopic(this, 'MyCfnTopic', /* all optional props */ {
archivePolicy: archivePolicy,
contentBasedDeduplication: false,
dataProtectionPolicy: dataProtectionPolicy,
deliveryStatusLogging: [{
protocol: 'protocol',
// the properties below are optional
failureFeedbackRoleArn: 'failureFeedbackRoleArn',
successFeedbackRoleArn: 'successFeedbackRoleArn',
successFeedbackSampleRate: 'successFeedbackSampleRate',
}],
displayName: 'displayName',
fifoThroughputScope: 'fifoThroughputScope',
fifoTopic: false,
kmsMasterKeyId: 'kmsMasterKeyId',
maximumMessageSize: 123,
signatureVersion: 'signatureVersion',
subscription: [{
endpoint: 'endpoint',
protocol: 'protocol',
}],
tags: [{
key: 'key',
value: 'value',
}],
topicName: 'topicName',
tracingConfig: 'tracingConfig',
});
from aws_cdk import CfnTag
# The code below shows an example of how to instantiate this type.
# The values are placeholders you should change.
from aws_cdk import aws_sns as sns
# archive_policy: Any
# data_protection_policy: Any
cfn_topic = sns.CfnTopic(self, "MyCfnTopic",
archive_policy=archive_policy,
content_based_deduplication=False,
data_protection_policy=data_protection_policy,
delivery_status_logging=[sns.CfnTopic.LoggingConfigProperty(
protocol="protocol",
# the properties below are optional
failure_feedback_role_arn="failureFeedbackRoleArn",
success_feedback_role_arn="successFeedbackRoleArn",
success_feedback_sample_rate="successFeedbackSampleRate"
)],
display_name="displayName",
fifo_throughput_scope="fifoThroughputScope",
fifo_topic=False,
kms_master_key_id="kmsMasterKeyId",
maximum_message_size=123,
signature_version="signatureVersion",
subscription=[sns.CfnTopic.SubscriptionProperty(
endpoint="endpoint",
protocol="protocol"
)],
tags=[CfnTag(
key="key",
value="value"
)],
topic_name="topicName",
tracing_config="tracingConfig"
)
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import software.amazon.awscdk.services.sns.*;
Object archivePolicy;
Object dataProtectionPolicy;
CfnTopic cfnTopic = CfnTopic.Builder.create(this, "MyCfnTopic")
.archivePolicy(archivePolicy)
.contentBasedDeduplication(false)
.dataProtectionPolicy(dataProtectionPolicy)
.deliveryStatusLogging(List.of(LoggingConfigProperty.builder()
.protocol("protocol")
// the properties below are optional
.failureFeedbackRoleArn("failureFeedbackRoleArn")
.successFeedbackRoleArn("successFeedbackRoleArn")
.successFeedbackSampleRate("successFeedbackSampleRate")
.build()))
.displayName("displayName")
.fifoThroughputScope("fifoThroughputScope")
.fifoTopic(false)
.kmsMasterKeyId("kmsMasterKeyId")
.maximumMessageSize(123)
.signatureVersion("signatureVersion")
.subscription(List.of(SubscriptionProperty.builder()
.endpoint("endpoint")
.protocol("protocol")
.build()))
.tags(List.of(CfnTag.builder()
.key("key")
.value("value")
.build()))
.topicName("topicName")
.tracingConfig("tracingConfig")
.build();
// Install: dotnet add package Amazon.CDK.Lib
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
using Amazon.CDK.AWS.SNS;
var archivePolicy;
var dataProtectionPolicy;
var cfnTopic = new CfnTopic(this, "MyCfnTopic", new CfnTopicProps {
ArchivePolicy = archivePolicy,
ContentBasedDeduplication = false,
DataProtectionPolicy = dataProtectionPolicy,
DeliveryStatusLogging = new [] { new LoggingConfigProperty {
Protocol = "protocol",
// the properties below are optional
FailureFeedbackRoleArn = "failureFeedbackRoleArn",
SuccessFeedbackRoleArn = "successFeedbackRoleArn",
SuccessFeedbackSampleRate = "successFeedbackSampleRate"
} },
DisplayName = "displayName",
FifoThroughputScope = "fifoThroughputScope",
FifoTopic = false,
KmsMasterKeyId = "kmsMasterKeyId",
MaximumMessageSize = 123,
SignatureVersion = "signatureVersion",
Subscription = new [] { new SubscriptionProperty {
Endpoint = "endpoint",
Protocol = "protocol"
} },
Tags = new [] { new CfnTag {
Key = "key",
Value = "value"
} },
TopicName = "topicName",
TracingConfig = "tracingConfig"
});
// Install: go get github.com/aws/aws-cdk-go/awscdk/v2
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import "github.com/aws/aws-cdk-go/awscdk"
var archivePolicy interface{}
var dataProtectionPolicy interface{}
cfnTopic := awscdk.Aws_sns.NewCfnTopic(this, jsii.String("MyCfnTopic"), &CfnTopicProps{
ArchivePolicy: archivePolicy,
ContentBasedDeduplication: jsii.Boolean(false),
DataProtectionPolicy: dataProtectionPolicy,
DeliveryStatusLogging: []interface{}{
&LoggingConfigProperty{
Protocol: jsii.String("protocol"),
// the properties below are optional
FailureFeedbackRoleArn: jsii.String("failureFeedbackRoleArn"),
SuccessFeedbackRoleArn: jsii.String("successFeedbackRoleArn"),
SuccessFeedbackSampleRate: jsii.String("successFeedbackSampleRate"),
},
},
DisplayName: jsii.String("displayName"),
FifoThroughputScope: jsii.String("fifoThroughputScope"),
FifoTopic: jsii.Boolean(false),
KmsMasterKeyId: jsii.String("kmsMasterKeyId"),
MaximumMessageSize: jsii.Number(123),
SignatureVersion: jsii.String("signatureVersion"),
Subscription: []interface{}{
&SubscriptionProperty{
Endpoint: jsii.String("endpoint"),
Protocol: jsii.String("protocol"),
},
},
Tags: []CfnTag{
&CfnTag{
Key: jsii.String("key"),
Value: jsii.String("value"),
},
},
TopicName: jsii.String("topicName"),
TracingConfig: jsii.String("tracingConfig"),
})
Initializer
new CfnTopic(scope: Construct, id: string, props?: CfnTopicProps)
CfnTopic(scope: Construct, id: str, props: typing.Optional[CfnTopicProps] = None)
new CfnTopic(Construct scope, String id, CfnTopicProps props)
new CfnTopic(Construct scope, string id, CfnTopicProps? props = null)
NewCfnTopic(Scope Construct, Id *string, Props CfnTopicProps)
Construct Props
archivePolicyoptionalanyarchive_policyoptionalAnyarchivePolicyoptionalObjectArchivePolicyoptionalobjectArchivePolicyoptionalinterface{}#You can set a retention period ranging from 1 to 365 days. This property is only applicable to FIFO topics; attempting to use it with standard topics will result in a creation failure.
contentBasedDeduplicationoptionalboolean | IResolvablecontent_based_deduplicationoptionaltyping.Union[bool, IResolvable]contentBasedDeduplicationoptionalBooleanContentBasedDeduplicationoptionalboolContentBasedDeduplicationoptionalinterface{}#notes
By default, this property is set to false. If you create a FIFO topic with ContentBasedDeduplication set to false, you must provide a MessageDeduplicationId for each Publish action. When set to true, Amazon automatically generates a MessageDeduplicationId using a SHA-256 hash of the message body (excluding message attributes). You can optionally override this generated value by specifying a MessageDeduplicationId in the Publish action. Note that this property only applies to FIFO topics; using it with standard topics will cause the creation to fail.
dataProtectionPolicyoptionalanydata_protection_policyoptionalAnydataProtectionPolicyoptionalObjectDataProtectionPolicyoptionalobjectDataProtectionPolicyoptionalinterface{}#You can only add one policy per topic.
The policy must be in JSON string format.
Length Constraints: Maximum length of 30,720.
deliveryStatusLoggingoptionalIResolvable | IResolvable | CfnTopic.LoggingConfigProperty[]delivery_status_loggingoptionaltyping.Union[IResolvable, typing.List[typing.Union[IResolvable, LoggingConfigProperty]]]deliveryStatusLoggingoptionalIResolvableDeliveryStatusLoggingoptionalIResolvableDeliveryStatusLoggingoptionalinterface{}#- HTTP
- Amazon Kinesis Data Firehose
- AWS Lambda
- Platform application endpoint
- Amazon Simple Queue Service
Once configured, log entries are sent to Amazon CloudWatch Logs.
displayNameoptionalstringdisplay_nameoptionalstrdisplayNameoptionalStringDisplayNameoptionalstringDisplayNameoptional*string#The display name must be maximum 100 characters long, including hyphens (-), underscores (_), spaces, and tabs.
fifoThroughputScopeoptionalstringfifo_throughput_scopeoptionalstrfifoThroughputScopeoptionalStringFifoThroughputScopeoptionalstringFifoThroughputScopeoptional*string#Valid values are Topic or MessageGroup .
fifoTopicoptionalboolean | IResolvablefifo_topicoptionaltyping.Union[bool, IResolvable]fifoTopicoptionalBooleanFifoTopicoptionalboolFifoTopicoptionalinterface{}#kmsMasterKeyIdoptionalstring | IAliasRef | IKeyRefkms_master_key_idoptionaltyping.Union[str, IAliasRef, IKeyRef]kmsMasterKeyIdoptionalStringKmsMasterKeyIdoptionalstringKmsMasterKeyIdoptionalinterface{}#notes
For more information, see Key terms . For more examples, see [KeyId](https://docs.aws.amazon.com/kms/latest/APIReference/API_DescribeKey.html#API_DescribeKey_RequestParameters) in the AWS Key Management Service API Reference .
This property applies only to server-side-encryption .
maximumMessageSizeoptionalnumbermaximum_message_sizeoptionalint | floatmaximumMessageSizeoptionalNumberMaximumMessageSizeoptionaldoubleMaximumMessageSizeoptional*float64#signatureVersionoptionalstringsignature_versionoptionalstrsignatureVersionoptionalStringSignatureVersionoptionalstringSignatureVersionoptional*string#By default, SignatureVersion is set to 1 .
subscriptionoptionalIResolvable | IResolvable | CfnTopic.SubscriptionProperty[]subscriptionoptionaltyping.Union[IResolvable, typing.List[typing.Union[IResolvable, SubscriptionProperty]]]subscriptionoptionalIResolvableSubscriptionoptionalIResolvableSubscriptionoptionalinterface{}#If you specify the
Subscriptionproperty in theAWS::SNS::Topicresource and it creates an associated subscription resource, the associated subscription is not deleted when theAWS::SNS::Topicresource is deleted.
tagsoptionalCfnTag[]tagsoptionaltyping.List[CfnTag]tagsoptionalList<CfnTag>TagsoptionalCfnTag[]Tagsoptional*[]CfnTag#To be able to tag a topic on creation, you must have the
sns:CreateTopicandsns:TagResourcepermissions.
topicNameoptionalstringtopic_nameoptionalstrtopicNameoptionalStringTopicNameoptionalstringTopicNameoptional*string#notes
Topic names must include only uppercase and lowercase ASCII letters, numbers, underscores, and hyphens, and must be between 1 and 256 characters long. FIFO topic names must end with .fifo .
If you don't specify a name, CloudFormation generates a unique physical ID and uses that ID for the topic name. For more information, see Name type .
If you specify a name, you can't perform updates that require replacement of this resource. You can perform updates that require no or some interruption. If you must replace the resource, specify a new name.
tracingConfigoptionalstringtracing_configoptionalstrtracingConfigoptionalStringTracingConfigoptionalstringTracingConfigoptional*string#notes
By default TracingConfig is set to PassThrough , and the topic passes through the tracing header it receives from an Amazon publisher to its subscriptions. If set to Active , Amazon will vend X-Ray segment data to topic owner account if the sampled flag in the tracing header is true.
Properties
CFN_RESOURCE_TYPE_NAMEstringcfn_resource_type_namestrCFN_RESOURCE_TYPE_NAMEStringCFN_RESOURCE_TYPE_NAMEstringCFN_RESOURCE_TYPE_NAME*stringstatic#cfnOptionsICfnResourceOptionscfn_optionsICfnResourceOptionscfnOptionsICfnResourceOptionsCfnOptionsICfnResourceOptionsCfnOptionsICfnResourceOptions#cfnResourceTypestringcfn_resource_typestrcfnResourceTypeStringCfnResourceTypestringCfnResourceType*string#contentBasedDeduplicationmay be undefinedboolean | IResolvablecontent_based_deduplicationmay be undefinedtyping.Union[bool, IResolvable]contentBasedDeduplicationmay be undefinedBooleanContentBasedDeduplicationmay be undefinedboolContentBasedDeduplicationmay be undefinedinterface{}#creationStackstring[]creation_stacktyping.List[str]creationStackList<String>CreationStackstring[]CreationStack*[]*string#dataProtectionPolicyanydata_protection_policyAnydataProtectionPolicyObjectDataProtectionPolicyobjectDataProtectionPolicyinterface{}#deliveryStatusLoggingmay be undefinedIResolvable | IResolvable | CfnTopic.LoggingConfigProperty[]delivery_status_loggingmay be undefinedtyping.Union[IResolvable, typing.List[typing.Union[IResolvable, LoggingConfigProperty]]]deliveryStatusLoggingmay be undefinedIResolvableDeliveryStatusLoggingmay be undefinedIResolvableDeliveryStatusLoggingmay be undefinedinterface{}#displayNamemay be undefinedstringdisplay_namemay be undefinedstrdisplayNamemay be undefinedStringDisplayNamemay be undefinedstringDisplayNamemay be undefined*string#fifoThroughputScopemay be undefinedstringfifo_throughput_scopemay be undefinedstrfifoThroughputScopemay be undefinedStringFifoThroughputScopemay be undefinedstringFifoThroughputScopemay be undefined*string#fifoTopicmay be undefinedboolean | IResolvablefifo_topicmay be undefinedtyping.Union[bool, IResolvable]fifoTopicmay be undefinedBooleanFifoTopicmay be undefinedboolFifoTopicmay be undefinedinterface{}#kmsMasterKeyIdmay be undefinedstringkms_master_key_idmay be undefinedstrkmsMasterKeyIdmay be undefinedStringKmsMasterKeyIdmay be undefinedstringKmsMasterKeyIdmay be undefined*string#The logical ID of the element is calculated from the path of the resource node in the construct tree.
To override this value, use overrideLogicalId(newLogicalId).
maximumMessageSizemay be undefinednumbermaximum_message_sizemay be undefinedint | floatmaximumMessageSizemay be undefinedNumberMaximumMessageSizemay be undefineddoubleMaximumMessageSizemay be undefined*float64#If, by any chance, the intrinsic reference of a resource is not a string, you could coerce it to an IResolvable through Lazy.any({ produce: resource.ref }).
signatureVersionmay be undefinedstringsignature_versionmay be undefinedstrsignatureVersionmay be undefinedStringSignatureVersionmay be undefinedstringSignatureVersionmay be undefined*string#CfnElements must be defined within a stack scope (directly or indirectly).
subscriptionmay be undefinedIResolvable | IResolvable | CfnTopic.SubscriptionProperty[]subscriptionmay be undefinedtyping.Union[IResolvable, typing.List[typing.Union[IResolvable, SubscriptionProperty]]]subscriptionmay be undefinedIResolvableSubscriptionmay be undefinedIResolvableSubscriptionmay be undefinedinterface{}#tagsRawmay be undefinedCfnTag[]tags_rawmay be undefinedtyping.List[CfnTag]tagsRawmay be undefinedList<CfnTag>TagsRawmay be undefinedCfnTag[]TagsRawmay be undefined*[]CfnTag#topicNamemay be undefinedstringtopic_namemay be undefinedstrtopicNamemay be undefinedStringTopicNamemay be undefinedstringTopicNamemay be undefined*string#topicRefTopicReferencetopic_refTopicReferencetopicRefTopicReferenceTopicRefTopicReferenceTopicRefTopicReference#tracingConfigmay be undefinedstringtracing_configmay be undefinedstrtracingConfigmay be undefinedStringTracingConfigmay be undefinedstringTracingConfigmay be undefined*string#Methods
addDeletionOverride(path: string): voiddef add_deletion_override(self, path: str) -> Nonepublic void addDeletionOverride(String path)public void AddDeletionOverride(string path)func AddDeletionOverride(Path *string)#1 parameter
Parameters
pathpathpathpathPath— The path of the value to delete.
addDependency(target: CfnResource): voiddef add_dependency(self, target: CfnResource) -> Nonepublic void addDependency(CfnResource target)public void AddDependency(CfnResource target)func AddDependency(Target CfnResource)deprecated#This method has been renamed to addResourceDependency to more clearly set it apart from construct.node.addDependency. See the documentation of that function for more details.
addDependsOn(target: CfnResource): voiddef add_depends_on(self, target: CfnResource) -> Nonepublic void addDependsOn(CfnResource target)public void AddDependsOn(CfnResource target)func AddDependsOn(Target CfnResource)deprecated#notes
This can be used for resources across stacks (or nested stack) boundaries and the dependency will automatically be transferred to the relevant scope.
This method has been renamed to addResourceDependency, which makes it more clear that this method operates at a different level from the construct-level construct.node.addDependency() mechanism.
addMetadata(key: string, value: any): voiddef add_metadata(self, key: str, value: Any) -> Nonepublic void addMetadata(String key, Object value)public void AddMetadata(string key, object value)func AddMetadata(Key *string, Value interface{})#addOverride(path: string, value: any): voiddef add_override(self, path: str, value: Any) -> Nonepublic void addOverride(String path, Object value)public void AddOverride(string path, object value)func AddOverride(Path *string, Value interface{})#notes · 2 parameters
To add a property override, either use addPropertyOverride or prefix path with "Properties." (i.e. Properties.TopicName).
If the override is nested, separate each nested level using a dot (.) in the path parameter. If there is an array as part of the nesting, specify the index in the path.
To include a literal . in the property name, prefix with a \. In most programming languages you will need to write this as "\\." because the \ itself will need to be escaped.
For example,
cfnResource.addOverride('Properties.GlobalSecondaryIndexes.0.Projection.NonKeyAttributes', ['myattribute']);
cfnResource.addOverride('Properties.GlobalSecondaryIndexes.1.ProjectionType', 'INCLUDE');
would add the overrides
"Properties": {
"GlobalSecondaryIndexes": [
{
"Projection": {
"NonKeyAttributes": [ "myattribute" ]
...
}
...
},
{
"ProjectionType": "INCLUDE"
...
},
]
...
}
The value argument to addOverride will not be processed or translated in any way. Pass raw JSON values in here with the correct capitalization for CloudFormation. If you pass CDK classes or structs, they will be rendered with lowercased key names, and CloudFormation will reject the template.
Parameters
pathpathpathpathPath— - The path of the property, you can use dot notation to override values in complex types.valuevaluevaluevalueValue— - The value.
addPropertyDeletionOverride(propertyPath: string): voiddef add_property_deletion_override(self, property_path: str) -> Nonepublic void addPropertyDeletionOverride(String propertyPath)public void AddPropertyDeletionOverride(string propertyPath)func AddPropertyDeletionOverride(PropertyPath *string)#1 parameter
Parameters
propertyPathproperty_pathpropertyPathpropertyPathPropertyPath— The path to the property.
addPropertyOverride(propertyPath: string, value: any): voiddef add_property_override(self, property_path: str, value: Any) -> Nonepublic void addPropertyOverride(String propertyPath, Object value)public void AddPropertyOverride(string propertyPath, object value)func AddPropertyOverride(PropertyPath *string, Value interface{})#Syntactic sugar for addOverride("Properties.<...>", value).
2 parameters
Parameters
propertyPathproperty_pathpropertyPathpropertyPathPropertyPath— The path of the property.valuevaluevaluevalueValue— The value.
addResourceDependency(target: CfnResource, reason?: string): voiddef add_resource_dependency(self, target: CfnResource, reason: typing.Optional[str] = None) -> Nonepublic void addResourceDependency(CfnResource target, String reason)public void AddResourceDependency(CfnResource target, string? reason = null)func AddResourceDependency(Target CfnResource, Reason *string)#notes
This can be used for resources across stacks (or nested stack) boundaries and the dependency will automatically be transferred to the relevant scope.
This method only adds dependencies between L1 resources. If you are looking for a generic construct-to-construct dependency mechanism that works for all constructs including L2s, use construct.node.addDependency instead.
applyCrossStackReferenceStrength(strength: ReferenceStrength): voiddef apply_cross_stack_reference_strength(self, strength: ReferenceStrength) -> Nonepublic void applyCrossStackReferenceStrength(ReferenceStrength strength)public void ApplyCrossStackReferenceStrength(ReferenceStrength strength)func ApplyCrossStackReferenceStrength(Strength ReferenceStrength)#When set, any cross-stack reference to this resource will use the specified strength instead of the global default from the consuming stack's context.
1 parameter
Parameters
strengthstrengthstrengthstrengthStrength— - The reference strength to use for this resource.
applyRemovalPolicy(policy?: RemovalPolicy, options?: RemovalPolicyOptions): voiddef apply_removal_policy(self, policy: typing.Optional[RemovalPolicy] = None, options: typing.Optional[RemovalPolicyOptions] = None) -> Nonepublic void applyRemovalPolicy(RemovalPolicy policy, RemovalPolicyOptions options)public void ApplyRemovalPolicy(RemovalPolicy? policy = null, RemovalPolicyOptions? options = null)func ApplyRemovalPolicy(Policy RemovalPolicy, Options RemovalPolicyOptions)#notes
The Removal Policy controls what happens to this resource when it stops being managed by CloudFormation, either because you've removed it from the CDK application or because you've made a change that requires the resource to be replaced.
The resource can be deleted (RemovalPolicy.DESTROY), or left in your AWS account for data recovery and cleanup later (RemovalPolicy.RETAIN). In some cases, a snapshot can be taken of the resource prior to deletion (RemovalPolicy.SNAPSHOT). A list of resources that support this policy can be found in the following link:
cfnPropertyName(cdkPropertyName: string): stringdef cfn_property_name(self, cdk_property_name: str) -> strpublic String cfnPropertyName(String cdkPropertyName)public string CfnPropertyName(string cdkPropertyName)func CfnPropertyName(CdkPropertyName *string) *string#getAtt(attributeName: string, typeHint?: ResolutionTypeHint): Referencedef get_att(self, attribute_name: str, type_hint: typing.Optional[ResolutionTypeHint] = None) -> Referencepublic Reference getAtt(String attributeName, ResolutionTypeHint typeHint)public Reference GetAtt(string attributeName, ResolutionTypeHint? typeHint = null)func GetAtt(AttributeName *string, TypeHint ResolutionTypeHint) Reference#Ideally, use generated attribute accessors (e.g. resource.arn), but this can be used for future compatibility in case there is no generated attribute.
1 parameter
Parameters
attributeNameattribute_nameattributeNameattributeNameAttributeName— The name of the attribute.
getMetadata(key: string): anydef get_metadata(self, key: str) -> Anypublic Object getMetadata(String key)public object GetMetadata(string key)func GetMetadata(Key *string) interface{}#inspect(inspector: TreeInspector): voiddef inspect(self, inspector: TreeInspector) -> Nonepublic void inspect(TreeInspector inspector)public void Inspect(TreeInspector inspector)func Inspect(Inspector TreeInspector)#1 parameter
Parameters
inspectorinspectorinspectorinspectorInspector— tree inspector to collect and process attributes.
isCfnElement(x: any): boolean@staticmethod def is_cfn_element(x: Any) -> boolpublic static Boolean isCfnElement(Object x)public static bool IsCfnElement(object x)func IsCfnElement(X interface{}) *boolstatic#Uses duck-typing instead of instanceof to allow stack elements from different versions of this library to be included in the same stack.
returns
Returns: The construct as a stack element or undefined if it is not a stack element.
isCfnResource(x: any): boolean@staticmethod def is_cfn_resource(x: Any) -> boolpublic static Boolean isCfnResource(Object x)public static bool IsCfnResource(object x)func IsCfnResource(X interface{}) *boolstatic#isCfnTopic(x: any): boolean@staticmethod def is_cfn_topic(x: Any) -> boolpublic static Boolean isCfnTopic(Object x)public static bool IsCfnTopic(object x)func IsCfnTopic(X interface{}) *boolstatic#isConstruct(x: any): boolean@staticmethod def is_construct(x: Any) -> boolpublic static Boolean isConstruct(Object x)public static bool IsConstruct(object x)func IsConstruct(X interface{}) *boolstatic#notes · 1 parameter · returns
Use this method instead of instanceof to properly detect Construct instances, even when the construct library is symlinked.
Explanation: in JavaScript, multiple copies of the constructs library on disk are seen as independent, completely different libraries. As a consequence, the class Construct in each copy of the constructs library is seen as a different class, and an instance of one class will not test as instanceof the other class. npm install will not create installations like this, but users may manually symlink construct libraries together or use a monorepo tool: in those cases, multiple copies of the constructs library can be accidentally installed, and instanceof will behave unpredictably. It is safest to avoid using instanceof, and using this type-testing method instead.
Parameters
xxxxX— Any object.
Returns: true if x is an object created from a class which extends Construct.
obtainDependencies(): Stack | CfnResource[]def obtain_dependencies(self, ) -> typing.List[typing.Union[Stack, CfnResource]]public List<Stack> obtainDependencies()public Stack[] ObtainDependencies()func ObtainDependencies() *[]interface{}#For resources depended on directly, returns the CfnResource object. For dependencies on other stacks, returns the Stack object. The order of the array is not guaranteed.
overrideLogicalId(newLogicalId: string): voiddef override_logical_id(self, new_logical_id: str) -> Nonepublic void overrideLogicalId(String newLogicalId)public void OverrideLogicalId(string newLogicalId)func OverrideLogicalId(NewLogicalId *string)#1 parameter
Parameters
newLogicalIdnew_logical_idnewLogicalIdnewLogicalIdNewLogicalId— The new logical ID to use for this stack element.
removeDependency(target: CfnResource): voiddef remove_dependency(self, target: CfnResource) -> Nonepublic void removeDependency(CfnResource target)public void RemoveDependency(CfnResource target)func RemoveDependency(Target CfnResource)deprecated#This can be used for resources across stacks (including nested stacks) and the dependency will automatically be removed from the relevant scope.
removeResourceDependency(target: CfnResource): voiddef remove_resource_dependency(self, target: CfnResource) -> Nonepublic void removeResourceDependency(CfnResource target)public void RemoveResourceDependency(CfnResource target)func RemoveResourceDependency(Target CfnResource)#This can be used for resources across stacks (including nested stacks) and the dependency will automatically be removed from the relevant scope.
replaceDependency(target: CfnResource, newTarget: CfnResource): voiddef replace_dependency(self, target: CfnResource, new_target: CfnResource) -> Nonepublic void replaceDependency(CfnResource target, CfnResource newTarget)public void ReplaceDependency(CfnResource target, CfnResource newTarget)func ReplaceDependency(Target CfnResource, NewTarget CfnResource)#2 parameters
Parameters
targettargettargettargetTarget— The dependency to replace.newTargetnew_targetnewTargetnewTargetNewTarget— The new dependency to add.
toString(): stringdef to_string(self, ) -> strpublic String toString()public string ToString()func ToString() *string#returns
Returns: a string representation of this resource
with(...mixins: IMixin[]): IConstructdef with(self, mixins: IMixin) -> IConstructpublic IConstruct with(IMixin mixins)public IConstruct With(IMixin mixins)func With(Mixins IMixin) IConstruct#Mixins are applied in order. The list of constructs is captured at the start of the call, so constructs added by a mixin will not be visited. Use multiple with() calls if subsequent mixins should apply to added constructs.